# rPLC coupler server which controls MOD-IO's relays' state over OPC-UA protocol.

[Link](rPLC coupler server which controls MOD-IO's relays' state over OPC-UA protocol.)

## Build and run

### Compile and install open62541 library (required)

ivan@k2-osie:~/open62541/build$ cmake -DBUILD_SHARED_LIBS=ON \
                                          -DCMAKE_BUILD_TYPE=RelWithDebInfo \
                                          -DUA_ENABLE_PUBSUB=ON \
                                          -DUA_ENABLE_PUBSUB_MONITORING=ON \
                                          -DUA_ENABLE_PUBSUB_ETH_UADP=ON \
                                          -DUA_NAMESPACE_ZERO=REDUCED \
                                          -DUA_ENABLE_ENCRYPTION=MBEDTLS \
                                          -DUA_ENABLE_ENCRYPTION_MBEDTLS=ON ..

ivan@k2-osie:~/open62541/build$ make

ivan@k2-osie:~/open62541/build$ sudo make install

ivan@k2-osie:~/open62541/build$ sudo ldconfig


### Build 

ivan@k2-osie:~/open62541/build$ gcc -I /usr/local/include/ -std=c99 ~/osie/coupler/server.c -o server -l:libopen62541.so -L/usr/local/lib -lmbedcrypto  -lmbedx509

### Run

$ ./server

### Run in virtual environment (on any x86_64 platform for testing purposes)

$ ./server -m 1
